var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};
__markAsModule(exports);
__export(exports, {
  default: () => src_default
});
var import_path = __toModule(require("path"));
var import_fs = __toModule(require("fs"));
var import_resolve_file = __toModule(require("resolve-file"));
var import_postcss = __toModule(require("postcss"));
var import_postcss_modules = __toModule(require("postcss-modules"));
var import_temp = __toModule(require("temp"));
var import_utils = __toModule(require("./utils"));
const LOAD_TEMP_NAMESPACE = "load_temp_namespace";
const LOAD_STYLE_NAMESPACE = "load_style_namespace";
const styleFilter = /.\.(css|sass|scss|less|styl)$/;
const handleCSSModules = (mapping) => (0, import_postcss_modules.default)({
  getJSON: (_, json) => {
    mapping.data = JSON.stringify(json, null, 2);
  }
});
const onStyleResolve = async (args) => {
  const {namespace, resolveDir} = args;
  let fullPath = (0, import_resolve_file.default)(args.path, {});
  if (!fullPath)
    fullPath = import_path.default.resolve(args.resolveDir, args.path);
  if (namespace === LOAD_STYLE_NAMESPACE) {
    return {
      path: fullPath,
      namespace: LOAD_TEMP_NAMESPACE,
      pluginData: {resolveDir}
    };
  }
  return {
    path: fullPath,
    namespace: LOAD_STYLE_NAMESPACE
  };
};
const onTempLoad = async (args) => {
  const {pluginData} = args;
  const data = await import_fs.default.promises.readFile(args.path);
  return {
    resolveDir: pluginData.resolveDir,
    contents: data,
    loader: "css"
  };
};
const onStyleLoad = (options) => async (args) => {
  const extract = options.extract === void 0 ? true : options.extract;
  const cssModulesMatch = options.cssModulesMatch || /\.module\./;
  const isCSSModule = args.path.match(cssModulesMatch);
  let css = await (0, import_utils.renderStyle)(args.path);
  let mapping = {data: {}};
  let plugins = options.postcss || [];
  let injectMapping = false;
  let contents = "";
  if (isCSSModule) {
    plugins = [handleCSSModules(mapping), ...plugins];
    injectMapping = true;
  }
  if (plugins.length > 0) {
    css = (await (0, import_postcss.default)(plugins).process(css, {from: args.path})).css;
    if (injectMapping)
      contents += `export default ${mapping.data};`;
  }
  if (extract) {
    const writestream = import_temp.default.createWriteStream({suffix: ".css"});
    writestream.write(css);
    writestream.end();
    contents += `import ${JSON.stringify(writestream.path)};`;
  }
  return {
    resolveDir: import_path.default.dirname(args.path),
    contents
  };
};
const plugin = (options = {}) => ({
  name: "esbuild-postcss-plugin",
  setup: (build) => {
    build.onResolve({filter: styleFilter}, onStyleResolve);
    build.onLoad({filter: /.*/, namespace: LOAD_TEMP_NAMESPACE}, onTempLoad);
    build.onLoad({filter: /.*/, namespace: LOAD_STYLE_NAMESPACE}, onStyleLoad(options));
  }
});
var src_default = plugin;
module.exports = plugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
