var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};
__markAsModule(exports);
__export(exports, {
  getModule: () => getModule,
  renderStyle: () => renderStyle
});
var import_util = __toModule(require("util"));
var import_path = __toModule(require("path"));
var import_fs = __toModule(require("fs"));
const getModule = (moduleName) => {
  try {
    require.resolve(moduleName);
  } catch {
    throw new Error(`Missing module. Please install '${moduleName}' package.`);
  }
  return require(moduleName);
};
const renderStyle = async (filePath, options = {}) => {
  const {ext} = import_path.default.parse(filePath);
  if (ext === ".css") {
    return await import_fs.default.promises.readFile(filePath);
  }
  if (ext === ".sass" || ext === ".scss") {
    const sassOptions = options.sassOptions || {};
    const sass = getModule("sass");
    return sass.renderSync({...sassOptions, file: filePath}).css.toString("utf-8");
  }
  if (ext === ".styl") {
    const stylusOptions = options.sassOptions || {};
    const stylus = getModule("stylus");
    const source = await import_fs.default.promises.readFile(filePath);
    return await stylus.render(new import_util.TextDecoder().decode(source), {...stylusOptions, filename: filePath});
  }
  if (ext === ".less") {
    const lestOptions = options.lessOptions || {};
    const less = getModule("less");
    const source = await import_fs.default.promises.readFile(filePath);
    return (await less.render(new import_util.TextDecoder().decode(source), {...lestOptions, filename: filePath})).css;
  }
  throw new Error(`Can't render this style '${ext}'.`);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getModule,
  renderStyle
});
